<template>
  <div v-loading="loading">
    <div class="white-box">
      <div class="filter-box">
        <filter-user ref="filterUser" :filter-types="filterTypes" @select-value="handleFilterUser"></filter-user>
      </div>
      <el-table :data="tableData" stripe style="width: 100%;" @selection-change="handleSelectionChange"
                 :height="tool.getTableHeight(true)">
        <el-table-column type="selection" width="55" v-if="tableHeaders"></el-table-column>
        <el-table-column v-for="(tableHeader, key) in tableHeaders" :key="key" :label="tableHeader.header" :width="tableHeader.other.width ? tableHeader.other.width : ''" :prop="tableHeader.other.prop ? tableHeader.other.prop : null">
          <template slot-scope="scope">
            <template v-if="scope.row[tableHeader.index].other.tag" >
              <el-tag :type="scope.row[tableHeader.index].other.tag.type ? scope.row[tableHeader.index].other.tag.type : null" :size="scope.row[tableHeader.index].other.tag.size ? scope.row[tableHeader.index].other.tag.size : null" :class="scope.row[tableHeader.index].other.tag.class ? scope.row[tableHeader.index].other.tag.class : null" >{{scope.row[tableHeader.index].value}}</el-tag>
            </template>
            <template v-else>
              <div v-html="scope.row[tableHeader.index].value"></div>
            </template>
          </template>
        </el-table-column>
      </el-table>
      <div class="white-box-footer">
        <el-button type="success" size="small" @click="handleExport" v-show="permission.hasPermission(`bonus/score-month-export`)">导出Excel</el-button>
        <pagination :total="totalCount" :page_size="pageSize" @size-change="handleSizeChange" @current-change="handleCurrentChange"></pagination>
      </div>
    </div>
  </div>
</template>

<script>
import network from '@/utils/network'
import tool from '@/utils/tool'
import baseInfo from '@/utils/baseInfo'
import FilterUser from '@/components/FilterUser'
import permission from '@/utils/permission'
import Pagination from '@/components/Pagination'
import filterHelper from '@/utils/filterHelper'

export default {
  name: 'leo-score-month-table',
  components: {FilterUser,Pagination},
  mounted () {
    this.getData()
  },
  data () {
    return {
      tableHeaders: null,
      tableData: null,
      loading: true,
      multipleSelection: [],
      currentPage: 1,
      totalPages: 1,
      totalCount: 1,
      pageSize: 20,
      tool: tool,
      permission: permission,
      baseDecLevels: baseInfo.decLevels(),
      baseEmpLevels: baseInfo.empLevels(),
      filterTypes: null,
      filterModel: {},
      filterStatus: 'ALL',
    }
  },
  methods: {
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    handleCurrentChange(page) {
      this.getData(page, this.pageSize)
    },
    handleSizeChange(pageSize) {
      this.getData(this.currentPage, pageSize)
    },

    handleFilterUser(filterData){
      filterHelper.handleFilterUser(this, filterData)
    },
    getData (page, pageSize) {
      let filterData = this.filterModel
      if(window.location.href.indexOf('filter') === -1){
        filterData.filterType = this.filterStatus !== 'ALL' ? `=,${this.filterStatus}` : ''
      }
      network.getPageData(this, 'bonus/score-month', page, pageSize, filterData, response=>{
        this.filterTypes = response.filterTypes
      })
    },
    handleExport () {
      let filterData = this.filterModel
      if(window.location.href.indexOf('filter') === -1){
        filterData.filterType = this.filterStatus !== 'ALL' ? `=,${this.filterStatus}` : ''
      }
      this.$confirm('确定要导出当前表格中的数据吗？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return network.getData('bonus/score-month-export', filterData)
      }).then(response => {
        this.$message({
          message: response,
          type: 'success'
        })
      }).catch(response => {
      })
    },
  }
}
</script>

<style>
  .leo-withdrawTable .el-form-item__label {
    width: 100px;
    color: #99a9bf;
  }

  .leo-withdrawTable .el-form-item {
    width: 40%;
    margin-right: 0;
    margin-bottom: 0;
  }
</style>
